#include "cRuCaptcha.h"

CRuCaptcha::CRuCaptcha(const QString& _API_KEY)
{
  API_KEY = _API_KEY;
  is_phrase = 0;
  is_regsense = 0;
  is_question = 0;
  is_numeric = 0;
  is_calc = 0;
  min_len = 0;
  max_len = 0;
  language = 0;
}
CRuCaptcha::CRuCaptcha(const QString& _API_KEY,
                       const bool& _is_phrase,
                       const bool& _is_regsense,
                       const bool& _is_question,
                       const short& _is_numeric,
                       const bool& _is_calc,
                       const int& _min_len,
                       const int& _max_len,
                       const short& _language,
                       const QString& _textinstructions,
                       const QString& _textcaptcha){

  API_KEY = _API_KEY;
  is_phrase = _is_phrase;
  is_regsense = _is_regsense;
  is_question = _is_question;
  is_numeric = _is_numeric;
  is_calc = _is_calc;
  min_len = _min_len;
  max_len = _max_len;
  language = _language;
  textinstructions = _textinstructions;
  textcaptcha = _textcaptcha;

}

bool CRuCaptcha::Recognize(const QString& path,QString& result){

  QByteArray Picture;
  //-------------------- read picture-----------------
  QFile File;
  File.setFileName(path);
  if(!File.open(QIODevice::ReadOnly)){
      result = File.errorString();
      return 0;
    }
  Picture = File.readAll();
  File.close();
  //-------------------- read picture-----------------

  QByteArray Header,PostData;

  //----------------------------------add post data------------------
  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"method\"\r\n";
  PostData += "\r\npost\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"key\"\r\n";
  PostData += "\r\n"+API_KEY.toLocal8Bit()+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"file\"; filename=\"capcha.jpg\"\r\n";
  PostData += "Content-Type: image/pjpeg\r\n";
  PostData += "\r\n"+Picture+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"phrase\"\r\n";
  PostData += "\r\n"+QByteArray::number(is_phrase)+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"regsense\"\r\n";
  PostData += "\r\n"+QByteArray::number(is_regsense)+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"question\"\r\n";
  PostData += "\r\n"+QByteArray::number(is_question)+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"numeric\"\r\n";
  PostData += "\r\n"+QByteArray::number(is_numeric)+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"calc\"\r\n";
  PostData += "\r\n"+QByteArray::number(is_calc)+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"min_len\"\r\n";
  PostData += "\r\n"+QByteArray::number(min_len)+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"max_len\"\r\n";
  PostData += "\r\n"+QByteArray::number(max_len)+"\r\n";

  PostData += "--27350115016941\r\n";
  PostData += "Content-Disposition: form-data; name=\"language\"\r\n";
  PostData += "\r\n"+QByteArray::number(language)+"\r\n";

  if(!textinstructions.isEmpty()){
      PostData += "--27350115016941\r\n";
      PostData += "Content-Disposition: form-data; name=\"textinstructions\"\r\n";
      PostData += "\r\n"+textinstructions.toLocal8Bit()+"\r\n";
    }
  if(!textcaptcha.isEmpty()){
      PostData += "--27350115016941\r\n";
      PostData += "Content-Disposition: form-data; name=\"textcaptcha\"\r\n";
      PostData += "\r\n"+textcaptcha.toLocal8Bit()+"\r\n";
    }
  //----------------------------------add post data------------------

  Header += "POST /in.php HTTP/1.0\r\n";
  Header += "Host: rucaptcha.com\r\n";
  Header += "Content-Type: multipart/form-data; boundary=27350115016941\r\n";
  Header += "Content-Length: "+QByteArray::number(PostData.length()+20)+"\r\n\r\n";

  socket.connectToHost("rucaptcha.com",80);

  socket.write(Header);
  socket.waitForBytesWritten();
  socket.write(PostData);
  socket.waitForBytesWritten();
  socket.write("--27350115016941--\r\n");
  socket.waitForBytesWritten();

  Header.clear();

  while(socket.waitForReadyRead(60000)){
      Header.append(this->socket.readAll());
    }

  //--------------------------------------------//

  int find = 0;
  find = Header.indexOf("\r\n\r\n");
  if(find == -1){
      result = "Socket error";
      socket.disconnect();
      return 0;
    }
  Header = Header.mid(find+4);
  find = Header.indexOf("|");
  if(find == -1){
      result = Header;
      socket.disconnect();
      return 0;
    }
  QByteArray id;
  id = Header.mid(find+1);

  //--------------------------------------------//
  //--------------------------------------------//


  Header.clear();
  Header += "GET /res.php?key="+API_KEY+"&action=get&id="+id+" HTTP/1.0\r\n";
  Header += "Host: rucaptcha.com\r\n\r\n";

  for(int i =0;i<10;i++){
      socket.disconnect();
      socket.connectToHost("rucaptcha.com",80);
      PostData.clear();

      socket.write(Header);
      socket.waitForBytesWritten();


      while(socket.waitForReadyRead(60000)){
          PostData.append(this->socket.readAll());
        }
      find = PostData.indexOf("\r\n\r\n");
      if(find == -1){
          socket.disconnect();
          result = "Socket error";
          return 0;
        }
      PostData = PostData.mid(find+4);
      find = PostData.indexOf("|");
      if(find == -1){
          if( PostData != "CAPCHA_NOT_READY"){
              result = PostData;
              socket.disconnect();
              return 0;
            }
        }else{
          result = PostData.mid(find+1);
          socket.disconnect();
          return 1;
        }
      QThread::sleep(5);
    }
  //--------------------------------------------//
  result = "time of expectation of analysis of captcha went out";
  return 0;
}

